//-----------------------------------------------------------------------------
// SIMDo{ˑ
// Copyright (c) 2008  N099
//-----------------------------------------------------------------------------
#include <windows.h>
#include <xmmintrin.h>
#include "cpuutl.h"

//------------------------------------------------------------------------
// SSEɑΉĂ邩`FbN
//------------------------------------------------------------------------
static int is_sse_available_itr(void);
static int is_sse_available_old(void);
static int is_sse_available_pf(void);
static int is_sse_supported_by_os(void);
typedef BOOL (WINAPI * IPFP)(DWORD);

int is_sse_available(void)
{
    int ret;

    ret = is_sse_available_pf();
    if(ret >= 0){
        return ret;
    }
#ifdef MSC_INTRIN_H_INCLUDED
    ret = is_sse_available_itr();
#else
    ret = is_sse_available_old();
#endif
    return ret;
}

int is_sse_available_pf(void)
{
    HMODULE h;
    IPFP ipf;

    h = GetModuleHandle(TEXT("Kernel32"));
    if(h == NULL){
        return -1;
    }

    //Win9xnɂ͑ΉȂ
    ipf = (IPFP)GetProcAddress(h, "IsProcessorFeaturePresent");
    if(ipf == NULL){
        return -1;
    }
    
    //SSE`FbN
    return ipf(PF_XMMI_INSTRUCTIONS_AVAILABLE) ? 1 : 0;
}

#ifdef MSC_INTRIN_H_INCLUDED
int is_sse_available_itr(void)
{
    int info[4] = { 0, 0, 0, 0 };
    
    __cpuid(info, 1);
    
    if(info[3] & 0x2000000){
        return is_sse_supported_by_os();
    }
    
    return 0;
}
#else
int is_sse_available_old(void)
{
#ifdef _MSC_VER // MSVĈݗL
    long r_ecx,r_edx;

    // CPUIDɂ`FbN
    __asm {
        mov eax, 1
        cpuid
        mov r_edx, edx
    }

    // MMX  0x0800000 edx
    // SSE  0x2000000 edx
    // SSE2 0x4000000 edx
    // SSE3 0x0000001 ecx
    r_edx &= 0x6800000;

    if(r_edx < 0x1000000)
        return 0;

    return is_sse_supported_by_os();
#else
    return 1;
#endif
}
#endif

int is_sse_supported_by_os(void)
{
    // OST|[gĂ邩
    __try {
        volatile __m128 x = { 0.0f, 0.0f, 0.0f, 0.0f };
        x = _mm_xor_ps(x, x);
    }

    __except(EXCEPTION_EXECUTE_HANDLER){
        if(_exception_code() == STATUS_ILLEGAL_INSTRUCTION)
            return 0;
    }

    return 1;
}

