//------------------------------------------------------------------------
//aviutlvOC cubic spline
// Copyright (c) 2007,2008  N099
//------------------------------------------------------------------------
#include <windows.h>
#include <malloc.h>
#include <xmmintrin.h>

#include "filter.h"
#include "cpuutl.h"
#include "spl.h"
#include "ddbox.h"

//------------------------------------------------------------------------
// \[XǗp
//------------------------------------------------------------------------
typedef struct _work_mem {
    void *p; //̃obt@
    size_t ww;
    int hs,ws;
    __m128 *temp;
    __m128 *weight;
    long padding[32];
    volatile long cnt[32];
} work_mem;

work_mem w_mem = { NULL, };

//Xbh̍ő吔
#define THREAD_MAX 16
#define ALIGN(a,b) (((a)+((b)-1))&~((b)-1))

//c̕P
#define V_UNIT 8

static BOOL mt_exec_dummy(MULTI_THREAD_FUNC fn, void *p1, void *p2);
static void mt_proc_h(int id, int num, void *para1, void *para2);
static void mt_proc_v(int id, int num, void *para1, void *para2);
static BOOL set_new_size(FILTER *fp);
static int alloc_wmem(work_mem *wm, int h, int w);

//------------------------------------------------------------------------
//tB^\̒`
//------------------------------------------------------------------------
TCHAR *track_name[]   = { "X", "Y" };
int   track_default[] = { 640, 480 };
int   track_s[] = {   32,   32 };
int   track_e[] = { 2048, 2048 };
enum  { T_X, T_Y };

TCHAR *check_name[] = { "cD" };
int check_default[] = { 0 };

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION, 0,0,
    "CXvC",
    ARRAYSIZE(track_name), track_name, track_default, track_s, track_e,
    ARRAYSIZE(check_name), check_name, check_default,
    func_proc,
    func_init,
    func_exit,
    NULL,
    func_WndProc,
    NULL, NULL, NULL, 0,
    "cspline by N099, ver1.4",
    NULL, NULL,

};

//------------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//------------------------------------------------------------------------
__declspec(dllexport) FILTER_DLL * __stdcall GetFilterTable( void )
{
    //SSEK{
    if(!is_sse_available()){
        filter.func_proc = NULL;
    }
    return &filter;
}

//------------------------------------------------------------------------
// ɌĂ΂֐
//------------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
    //őTCY擾
    SYS_INFO si = {0};
    if(!fp->exfunc->get_sys_info(NULL, &si)){
        return FALSE;
    }else{
        track_s[0] = si.min_w;
        track_s[1] = si.min_h;
        track_e[0] = si.max_w;
        track_e[1] = si.max_h;
        fp->exfunc->filter_window_update(fp);
    }
    
    return TRUE;
}

//------------------------------------------------------------------------
// IɌĂ΂֐
//------------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
    if(w_mem.p != NULL){
        VirtualFree(w_mem.p, 0, MEM_RELEASE);
        ZeroMemory(&w_mem, sizeof(w_mem));
    }

    return TRUE;
}

//------------------------------------------------------------------------
// tB^֐
//------------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
    BOOL (*exec_mt)(MULTI_THREAD_FUNC, void*, void*) = NULL;
    RECT rsize;
    
    //Ɨ̈̊m
    if(alloc_wmem(&w_mem, fpip->max_h, fpip->max_w)){
        return FALSE;
    }

    //}`Xbh֐płꍇg
    exec_mt = fp->exfunc->exec_multi_thread_func;
    if(exec_mt == NULL) exec_mt = mt_exec_dummy;

    if(fp->check[0]){
        //->̏ŏ
        if(fp->track[T_Y] != fpip->h){
            //̃TCY
            SetRect(&rsize, fpip->w, fpip->h, fpip->w, fp->track[T_Y]);
            if(!exec_mt(mt_proc_v, fpip->ycp_edit, &rsize)){
                return FALSE;
            }
            fpip->h = fp->track[T_Y];
        }
        if(fp->track[T_X] != fpip->w){
            //̃TCY
            SetRect(&rsize, fpip->w, fpip->h, fp->track[T_X], fpip->h);
            if(!exec_mt(mt_proc_h, fpip->ycp_edit, &rsize)){
                return FALSE;
            }
            fpip->w = fp->track[T_X];
        }
    }else{
        //->
        if(fp->track[T_X] != fpip->w){
            //̃TCY
            SetRect(&rsize, fpip->w, fpip->h, fp->track[T_X], fpip->h);
            if(!exec_mt(mt_proc_h, fpip->ycp_edit, &rsize)){
                return FALSE;
            }
            fpip->w = fp->track[T_X];
        }
        if(fp->track[T_Y] != fpip->h){
            //̃TCY
            SetRect(&rsize, fpip->w, fpip->h, fpip->w, fp->track[T_Y]);
            if(!exec_mt(mt_proc_v, fpip->ycp_edit, &rsize)){
                return FALSE;
            }
            fpip->h = fp->track[T_Y];
        }
    }

    return TRUE;
}

//------------------------------------------------------------------------
// }`Xbh֐
//------------------------------------------------------------------------
BOOL mt_exec_dummy(MULTI_THREAD_FUNC fn, void *p1, void *p2)
{
    fn(0, 1, p1, p2);
    return TRUE;
}

void mt_proc_h(int id, int num, void *para1, void *para2)
{
    PIXEL_YC *pyc = para1;
    __m128 *px = w_mem.temp + id * w_mem.ww;
    RECT *rsize = (RECT*)para2;
    int i,c;
    unsigned int csr;
#if 0
    volatile void *dummy = _alloca(id * 128); //for HTT
#endif
    
    //z肷őXbh𒴂
    num = num>THREAD_MAX ? THREAD_MAX : num;
    if(id >= THREAD_MAX) return;
    
    //flush to zero mode LiXbhƁj
    csr = _mm_getcsr();
    _mm_setcsr(_MM_MASK_MASK|_MM_FLUSH_ZERO_MASK);

    //摜𐅕ŕ
    if(num > 1){
        //C𕪊
        while((i = _InterlockedIncrement(w_mem.cnt + 1) - 1) < rsize->top){
            c = w_mem.ws * i;
            spl_make_ddh_yc(pyc + c, px, w_mem.weight, rsize->left);
            spl_hinterporate_yc(pyc + c, px, rsize->left, rsize->right);
        }
    }else{
        for(i=0; i<rsize->top; ++i){
            c = w_mem.ws * i;
            spl_make_ddh_yc(pyc + c, px, w_mem.weight, rsize->left);
            spl_hinterporate_yc(pyc + c, px, rsize->left, rsize->right);
        }
    }

    _mm_setcsr(csr);
    _mm_empty();
}

void mt_proc_v(int id, int num, void *para1, void *para2)
{
    __m64  *pyc = para1;
    __m128 *px = w_mem.temp + id * w_mem.ww;
    RECT *rsize = (RECT*)para2;
    int i,c,mw,ms;
    unsigned int csr;
#if 0
    volatile void *dummy = _alloca(id * 128); //for HTT
#endif

    //z肷őXbh𒴂
    num = num>THREAD_MAX ? THREAD_MAX : num;
    if(id >= THREAD_MAX) return;
    
    //flush to zero mode LiXbhƁj
    csr = _mm_getcsr();
    _mm_setcsr(_MM_MASK_MASK|_MM_FLUSH_ZERO_MASK);

    //64bitPʂɊZ
    ms = (w_mem.ws * sizeof(PIXEL_YC))/sizeof(__m64); //؂O
    mw = (rsize->left * sizeof(PIXEL_YC)) + (sizeof(__m64) - 1);
    mw /= sizeof(__m64);
    
    //摜𐂒ŕ
    if(num > 1){
        while((c = V_UNIT * _InterlockedIncrement(w_mem.cnt)) < mw + V_UNIT){
            i = c - V_UNIT;
            c = c > mw ? mw : c;
            for( ; i<c; ++i){
                spl_make_ddv_yc(pyc+i, px, w_mem.weight, rsize->top, ms);
                spl_vinterporate_yc(pyc+i, px, rsize->top, rsize->bottom, ms);
            }
        }
    }else{
        for(i=0 ; i<mw; ++i){
            spl_make_ddv_yc(pyc+i, px, w_mem.weight, rsize->top, ms);
            spl_vinterporate_yc(pyc+i, px, rsize->top, rsize->bottom, ms);
        }
    }

    _mm_setcsr(csr);
    _mm_empty();
}

//------------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//------------------------------------------------------------------------
BOOL func_WndProc(HWND hwnd, UINT message, WPARAM wparam,
                  LPARAM lparam, void *editp, FILTER *fp)
{
    switch(message){
      case WM_COMMAND:
        switch(HIWORD(wparam)){
          case BN_CLICKED:
            if(LOWORD(wparam) == IDC_SETSIZE){
                return set_new_size(fp);
            }
        }
        break;
      case WM_FILTER_CHANGE_ACTIVE:
        if(!fp->exfunc->is_filter_active(fp)){
            //\[XJ
            func_exit(NULL);
        }
        break;
      case WM_FILTER_INIT:
        return ddbox_init(hwnd, fp, check_name[0]);
      case WM_FILTER_EXIT:
        return ddbox_exit(hwnd, fp);
      default:
        break;
    }

    return FALSE;
}

//------------------------------------------------------------------------
// Xg{bNXŎw肳ꂽTCY擾ăZbg
//------------------------------------------------------------------------
BOOL set_new_size(FILTER *fp)
{
    POINT pt;

    if(ddbox_get_size(&pt)){
        //擾łꍇɃTCYZbg
        fp->track[T_X] = min(max(fp->track_s[T_X], pt.x), fp->track_e[T_X]);
        fp->track[T_Y] = min(max(fp->track_s[T_Y], pt.y), fp->track_e[T_Y]);
        return fp->exfunc->filter_window_update(fp);
    }else{
        return FALSE;
    }
}

//------------------------------------------------------------------------
// ̈m
//------------------------------------------------------------------------
int alloc_wmem(work_mem *wm, int h, int w)
{
    size_t sz,sz_w;

    //JE^̃NAiœ֐ĂԂ̂Ŗ{͑OKj
    _InterlockedExchange(wm->cnt,     0);
    _InterlockedExchange(wm->cnt + 1, 0);
    
    // őTCY͕ωȂ͂Ȃ̂ňxmۂOK
    if(wm->p){
        return 0;
    }

    // ŜAP[giw4̔{łOj
    sz_w = h>w ? h : w;
    sz_w = ALIGN((unsigned int)(sz_w + 2 + 1), 8); //[:2,K[h:1
    sz = (sz_w + 2 * sz_w * THREAD_MAX) * sizeof(__m128);
    wm->p = VirtualAlloc(NULL, sz, MEM_COMMIT, PAGE_READWRITE);
    if(NULL == wm->p){
        return -1;
    }

    // eobt@ʒuvZ
    wm->temp = (__m128*)wm->p;
    wm->weight = wm->temp + 2 * sz_w * THREAD_MAX;

    wm->hs = h;
    wm->ws = w;
    wm->ww = 2 * sz_w;

    //ď݂vZ
    spl_update_weight(wm->weight, sz_w);
    
    return 0;
}


